<template>
  <v-card name="subscription-list">
    <v-toolbar
      color="teal"
      :dense="sidebar"
    >
      <v-app-bar-nav-icon><v-icon>assignment</v-icon></v-app-bar-nav-icon>
      <v-toolbar-title
        v-if="!sidebar"
        style="min-width: fit-content;"
      >
        Tasks
      </v-toolbar-title>
      <v-spacer />
      <v-select
        v-model="selectedGroup"
        :items="groups"
        item-text="name"
        return-object
        hide-details
        solo
        flat
        background-color="teal"
      />
      <v-btn
        icon
        @click="getAvailableSubmissionCount(false)"
      >
        <v-icon v-if="!updating">
          refresh
        </v-icon>
        <v-progress-circular
          v-else
          indeterminate
          color="black"
          size="20"
        />
      </v-btn>
    </v-toolbar>
    <v-tabs
      v-if="showDetail"
      v-model="selectedStage"
      grow
      color="black"
      background-color="teal lighten-1"
    >
      <v-tab
        v-for="(item, i) in stagesReadable"
        :key="i"
      >
        {{ item }}
      </v-tab>
      <v-tab-item
        v-for="(stage, i) in stages"
        :key="i"
      >
        <subscriptions-for-stage
          :id="`stage-${i}`"
          :stage="stage"
        />
      </v-tab-item>
    </v-tabs>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop, Watch } from 'vue-property-decorator'
import { mapGetters, mapActions, mapState } from 'vuex'
import { UI } from '@/store/modules/ui'
import { actions } from '@/store/actions'
import SubscriptionForList from '@/components/subscriptions/SubscriptionForList.vue'
import SubscriptionsForStage from '@/components/subscriptions/SubscriptionsForStage.vue'
import { Assignments } from '@/store/modules/assignments'
import store from '../../store/store'
import { FeedbackStageEnum, Group } from '../../models'
import { Authentication } from '../../store/modules/authentication'
import { ConfigModule } from '../../store/modules/config'

@Component({
  name: 'subscription-list',
  components: {
    SubscriptionsForStage,
    SubscriptionForList,
  },
})
export default class SubscriptionList extends Vue {
  @Prop({type: Boolean, default: false}) sidebar!: boolean

  updating = false
  timer = 0

  get stages () { return Assignments.availableStages }
  get stagesReadable () { return Assignments.availableStagesReadable }
  get showDetail () {
    return !this.sidebar || (this.sidebar && !UI.state.sideBarCollapsed)
  }
  get groups () {
    return Assignments.state.groups.slice()
          .filter(group => {
            return group.exam === null || group.exam.pk === ConfigModule.state.config.examId
          })
          .sort((a, b) => {
        const matches_a = a.name.match(/(\d+)/)
        const number_a = Number(matches_a === null ? 0 : matches_a[1])

        const matches_b = b.name.match(/(\d+)/)
        const number_b = Number(matches_b === null ? 0 : matches_b[1])

        return (number_a<number_b?-1:(number_a>number_b?1:0))
      })
  }

  get selectedStage() {
    const val = Assignments.state.assignmentCreation.stage
    switch (val) {
      case FeedbackStageEnum.Creation: return 0
      case FeedbackStageEnum.Validation: return 1
      case FeedbackStageEnum.Review: return 2
      default:
          throw new Error(`Illegal value ${val} in get selectedStage`)
    }
  }

  set selectedStage(val) {
    const map_number_to_stage = (val: number): FeedbackStageEnum => {
      switch (val) {
        case 0: return FeedbackStageEnum.Creation
        case 1: return FeedbackStageEnum.Validation
        case 2: return FeedbackStageEnum.Review
        default:
          throw new Error(`Illegal value ${val} in set selectedStage`)
      }
    }
    Assignments.SET_CREATE_STAGE(map_number_to_stage(val))
  }

  get selectedGroup() {
    return Assignments.state.assignmentCreation.group
  }

  set selectedGroup(val: Group | undefined) {
    if (val === undefined) {
      throw new Error('Setting create group to undefined is not allowed')
    }
    Assignments.SET_CREATE_GROUP(val)
    Assignments.getAvailableSubmissionCounts()
  }


  async getAvailableSubmissionCount (silent: boolean) {
    if (silent === false) {
      this.updating = true
    }
    await Assignments.getAvailableSubmissionCounts()
    this.updating = false
  }

  beforeDestroy() {
    clearInterval(this.timer)
  }

  created() {
    const ownGroup = Authentication.state.user.exerciseGroups[0]
    if (ownGroup !== undefined) {
      this.selectedGroup = ownGroup
    }

    const submissionTypes = actions.updateSubmissionTypes()
    const groups = Assignments.getGroups()
    Promise.all([submissionTypes, groups]).then(() => {
      this.getAvailableSubmissionCount(false)

      this.timer = setInterval(() => {
        this.getAvailableSubmissionCount(true)
      }, 30 * 1e3)
    })

    Promise.all([submissionTypes]).then(() => {
      Assignments.cleanAssignments()
    })
  }
}
</script>

<style scoped>

</style>
